//
// Copy class for PTC 2.0 C++ API
// Copyright (c) 1998 Glenn Fiedler (ptc@gaffer.org)
// This source code is licensed under the GNU LGPL
//

#ifndef __PTC_COPY_H
#define __PTC_COPY_H

// include files
#include "Hermes\Hermes.h"
#include "Types.h"
#include "Index.h"




class Copy
{
    public:
        Copy();
        ~Copy();

        // request conversion
        void request(const Format &source,const Format &destination);

        // set copy palettes
        void palette(const int32 source[],const int32 destination[]);

        // copy pixels
        void copy(const void *s_pixels,int s_x,int s_y,int s_width,int s_height,int s_pitch,
                  void *d_pixels,int d_x,int d_y,int d_width,int d_height,int d_pitch);

    private:
        void Copy::convertformat(const Format& source,HermesFormat *dest);
};




#endif
