//
// Definitions for x86 assembler routines for the HERMES library
// Copyright (c) 1998 Christian Nentwich (brn@eleet.mcb.at)
// This source code is licensed under the GNU LGPL
//
// Please refer to the file COPYING.LIB contained in the distribution for
// licensing conditions
//
#ifndef __HERMES_CONV_X86_H__
#define __HERMES_CONV_X86_H__

#include <stdlib.h>
#include "Base.h"

void Hermes_x86_init();
void Hermes_x86_close();
char Hermes_x86_request(HermesFormat *source,HermesFormat *dest,char stretch);
void Hermes_x86_palette(int32 *palette);
void Hermes_x86_copy(void *s_pixels,int s_x,int s_y,int s_width,int s_height,
		    int s_pitch,void *d_pixels,int d_x,int d_y,int d_width,
		    int d_height,int d_pitch);
void Hermes_x86_gentables();


static BaseConverter Hermes_x86=
{ NULL, 
  NULL,
  0,
  Hermes_x86_init,
  Hermes_x86_close,
  Hermes_x86_request,
  Hermes_x86_palette,
  Hermes_x86_copy
};


#endif

