/*
   Generic C converter (from 8 bit indexed) for the HERMES library
   Copyright (c) 1998 Christian Nentwich (brn@eleet.mcb.at)
   This source code is licensed under the GNU LGPL
  
   Please refer to the file COPYING.LIB contained in the distribution for
   licensing conditions
*/


#include "HermConf.h"
#include "HeadC.h"




void ConvertC_index8_32(HermesConverterInterface *iface)
{ int i;
  char8 s_pixel;
  int32 d_pixel;
  char8 *source=(char8 *)iface->s_pixels;
  char8 *dest=(char8 *)iface->d_pixels;

  while (iface->s_height--) {
    
    for(i=0;i<iface->s_width;i++,source++,dest+=4)
    { s_pixel=(char8)*(source);

      d_pixel=iface->lookup[s_pixel];
      WRITE32(dest,d_pixel);
    }
    
    source+=iface->s_add;
    dest+=iface->d_add;
  }

}


void ConvertC_index8_24(HermesConverterInterface *iface)
{ int i;
  char8 s_pixel;
  int32 d_pixel;
  char8 *d_ptr=(char8 *)&d_pixel;
  char8 *source=iface->s_pixels;
  char8 *dest=iface->d_pixels;

  while (iface->s_height--) {

    for(i=0;i<iface->s_width;i++,source++,dest+=3)
    { s_pixel=(char8)*(source);

      d_pixel=iface->lookup[s_pixel];

      *(dest+R_24)=*(d_ptr+R_32);
      *(dest+G_24)=*(d_ptr+G_32);
      *(dest+B_24)=*(d_ptr+B_32);
    
      WRITE32(dest,d_pixel);
    }
    
    source+=iface->s_add;
    dest+=iface->d_add;
  }
}



void ConvertC_index8_16(HermesConverterInterface *iface)
{ unsigned int i;
  int32 d_pixel;
  char8 *source=iface->s_pixels;
  char8 *dest=iface->d_pixels;
  int count;

  while (iface->s_height--) {

    count=iface->s_width;

    if(((int)dest&0x3)!=0)
    { WRITE16(dest++,iface->lookup[*source++]);

      dest++;
      count--;
    }

    for(i=0;i<count>>1;i++,source+=2,dest+=4)
    { d_pixel=DWORD_BYTE0(iface->lookup[(char8)*(source)]);
      d_pixel|=DWORD_BYTE2(iface->lookup[(char8)*(source+1)]);
    
      WRITE32(dest,d_pixel);  
    }

    if(count&1)
    WRITE16(dest,iface->lookup[*source]);
    
    source+=iface->s_add;
    dest+=iface->d_add;
  }
}




















