//
// Error class for PTC 2.0 C++ API
// Copyright (c) 1998 Glenn Fiedler (ptc@gaffer.org)
// This source code is licensed under the GNU LGPL
//

#ifndef __PTC_ERROR_H
#define __PTC_ERROR_H




class Error
{
    public:

        // constructor
        Error();
        Error(const char message[]);
	Error(const Error &other);

	// destructor
        ~Error();
 
        // rethrow error
        void rethrow(char message[]);

        // report
        void report() const;

        // data access
        const char* message() const;

	Error& operator =(const Error &other);
        bool operator ==(const Error &other) const;
        bool operator !=(const Error &other) const;

    private:

        // error message
        char m_message[1024];
};




#endif
