//
// Base Error interface for PTC 2.0 C++ API
// Copyright (c) 1998 Glenn Fiedler (ptc@gaffer.org)
// This source code is licensed under the GNU LGPL
//

#ifndef __PTC_BASE_ERROR_H
#define __PTC_BASE_ERROR_H

// include files
#include "Base/Index.h"




namespace ptc
{
    namespace Base
    {
        class Error
        {
            public:

                // rethrow error
                virtual void rethrow(const char message[]) = 0;

                // report error
                virtual void report() const = 0;

                // get error message
                virtual const char* message() const = 0;

                // operators
                virtual Error& operator =(const Error &other) = 0;
                virtual bool operator ==(const Error &other) const = 0;
                virtual bool operator !=(const Error &other) const = 0;
        };
    }
}




#endif
