//
// Error class for OpenPTC 1.0 C++ Implementation
// Copyright (c) 1999 Glenn Fiedler (ptc@gaffer.org)
// This source code is licensed under the GNU LGPL
//

#ifndef __PTC_ERROR_H
#define __PTC_ERROR_H

// include files
#include "Core/Types.h"
#include "Core/Config.h"




class Error
{
    public:

        // setup
        DLLAPI PTCAPI Error();
        DLLAPI PTCAPI Error(const char message[]);
        DLLAPI PTCAPI Error(const char message[],const Error &error);
        DLLAPI PTCAPI Error(const Error &error);
        DLLAPI PTCAPI ~Error();

        // report error
        DLLAPI void PTCAPI report() const;

        // get error message
        DLLAPI const char* PTCAPI message() const;

        // operators
        DLLAPI Error& PTCAPI operator =(const Error &error);
        DLLAPI bool PTCAPI operator ==(const Error &error) const;
        DLLAPI bool PTCAPI operator !=(const Error &error) const;

    private:

        // defaults
        void defaults();

        // error message
        char *m_message;
};




#endif
