//
// Monitor class for PTC 2.0 C++ API
// Copyright (c) 1998 Glenn Fiedler (ptc@gaffer.org)
// This source code is licensed under the GNU LGPL
//

// include files
#include "Win32/Monitor.h"

// using directive
using namespace ptc::Win32;




Monitor::Monitor()
{
    // initialize critical section
    InitializeCriticalSection(&m_handle);
}


Monitor::~Monitor()
{
    // delete critical section
    DeleteCriticalSection(&m_handle);
}




void Monitor::enter()
{
    // enter critical section
    EnterCriticalSection(&m_handle);
}


void Monitor::leave()
{
    // leave critical section
    LeaveCriticalSection(&m_handle);
}
